<?

// prueft auf syntaktisch korrekte ip-adresse,
// die nicht zu einem privatem netzwerk gehoert
// (ausgeschlossen sind: 10/24, 127/24, 192.168/16,
//	172.16/16 - 172.31/16, 0.0.0.0, 255.255.255.255)
function checkIP($ip2check, $checkEmpty = 1) {
	if ($checkEmpty && $ip2check == "") return 0;
	
	$block = "([01]?\d?\d|2[0-4]\d|25[0-5])";
	$ip    = "$block\.$block\.$block\.$block";
	$badIP = "(0?10\..+|127\..+|192\.168\..+|172\.0?1[6-9]\..+|".
			"172\.0?2[0-9]\..+|172\.0?3[01]\..+|".
			"0?0?0\.0?0?0\.0?0?0\.0?0?0|255\.255\.255\.255)";

	if (!preg_match('/^'.$ip.'$/',    $ip2check)) return 0;
	if ( preg_match('/^'.$badIP.'$/', $ip2check)) return 0;

	return 1;
}

// prueft auf eine systaktisch korrekte email
function checkEMail($email2check, $checkEmpty = 1) {
	$email2check = strtolower($email2check);
	if ($checkEmpty && $email2check == "")  return 0;
	if (!preg_match('/^.+@(.+\.)+.{2,5}$/', $email2check)  ||
		 preg_match('/[^0-9a-z@_\.-]/',     $email2check))  {
		return 0;
	} else {
		return 1;
	}
}

// prueft ob der string andere zeichen als 0-9, a-z, A-Z enthaelt
function checkAZ09only($string2check, $checkEmpty = 1) {
	if ($checkEmpty && $string2check == "") return 0;
	if (preg_match('/[^a-zA-Z0-9]/', $string2check)) return 0;

	return 1;
}

// gibt bereinigten string zurueck (zulaessig: a-z, A-Z, 0-9, ' ', '.', '-')
function cleanString($string2clean) {
	$string2clean = preg_replace('/[^a-zA-Z0-9 .-]/', '', $string2clean);

	return $string2clean;
}

// prueft url auf syntax - vorerst dummy
function checkURL($url2check, $checkEmpty = 1) {
	if ($checkEmpty && $url2check == "")  return 0;

	// hier folgt eigentliche regex
	// gewuenschte / erlaubte sonderfaelle zu klaeren:
	// - protokolle: http(s), ftp, ...
	// - nutzer/passwort
	// - nur mit und ohne www - oder beliebige subdomains
	// - pfad(e)
	// - parameter
	// - html-anker (#)

	return 1;
}

// prueft domain auf syntax - vorerst dummy
function checkDomain($domain2check, $checkEmpty = 1) {
	if ($checkEmpty && $domain2check == "")  return 0;

	// hier folgt eigentliche regex
	// gewuenschte / erlaubte sonderfaelle zu klaeren:
	// - nur bestimmte tld's oder alle (derzeit) bekannten
	// - sub-tld's z.b. .co.at

	return 1;
}

// beispiele
$str = "255.123.456.12354";
echo "$str -> checkIP: ".checkIP($str)."\n";
$str = "155.123.156.123";
echo "$str -> checkIP: ".checkIP($str)."\n";

$str = "255.123.456.12354";
echo "$str -> checkEmail ".checkEMail($str)."\n";
$str = "hans@doedel.de";
echo "$str -> checkEmail ".checkEMail($str)."\n";

$str = "255.123.456.12 354";
echo "$str -> checkAZ09only: ".checkAZ09only($str)."\n";
$str = "abcAJHGJH255";
echo "$str -> checkAZ09only: ".checkAZ09only($str)."\n";

$str = "2jshdfg()'\/\$§#-,,%< >!5.1JHJ'G23";
echo "$str -> cleanString: ".cleanString($str)."\n";

?>